source [file join $script_path unit.tcl]

# Board --
#
#   board of paccraft

inherit Board Control
method Board constructor {parent board} {
	BoardA ${objName}_abst $objName
	this inherited $parent ${objName}_abst
	
	${objName}_abst set $board
}

method Board destructor {} {
	this inherited
}


# BoardA --
#
#   board abstraction

inherit BoardA Abstraction
method BoardA constructor {control} {
	this inherited $control
	set this(next_id) 0
}

method BoardA set {board} {
	foreach {position Unit} $board {
		set name ${objName}_unit_$this(next_id)
		$Unit $name $this(control) $position
		set this($position) $name

		incr this(next_id)
	}
}
